import numpy as np
import PIL.Image
import tensorflow as tf
from IPython import display


def show(img):
    """Display an image."""
    img = np.array(img)
    img = np.squeeze(img)
    display.display(PIL.Image.fromarray(img))


def deprocess(img):
    """Normalize image for display."""
    img = tf.squeeze(img)
    img = 255 * (img + 1.0) / 2.0
    return tf.cast(img, tf.uint8)


def get_image(source, max_dim=None):
    """Retrieve an image from a URL or a local path and load it as a NumPy array."""
    if os.path.exists(source):  # A directory path to some image
        image_path = source
    else:
        name = source.split("/")[-1]  # A URL to some image 
        image_path = tf.keras.utils.get_file(name, origin=source)

    img = tf.keras.utils.load_img(image_path)
    img = keras.utils.img_to_array(img)
    
    if max_dim:
        img.thumbnail((max_dim, max_dim))
    
    return np.array(img)


def preprocess_image(image_path):
    img = keras.utils.load_img(image_path)
    img = keras.utils.img_to_array(img)
    img = np.expand_dims(img, axis=0)
    img = keras.applications.inception_v3.preprocess_input(img)
    return img
